/*
 *	main.c
 *
 *	tbVRXǂ
 *
 *	* Sun Nov 06 14:15:00 JST 2005 Naoyuki Sawa
 *	- 1st [XB
 */
#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

#ifdef USE_MUSIC
#include "instdef2.c"
#endif /*USE_MUSIC*/

#ifdef USE_SPRITE
#define SPRITE_ SPRITE_INIT2
const SPRITE sprite_table[SPRITE_COUNT] = {
#include "sprite.h"
};
#undef SPRITE_
#endif /*USE_SPRITE*/

#define extern
#include "work.h"
#undef extern

/****************************************************************************
 *	萔Ee[uEp^[
 ****************************************************************************/

//                        RI RD DN LD LF LU UP RU
const short dir_col[8] = { 1, 1, 0,-1,-1,-1, 0, 1 };
const short dir_row[8] = { 0, 1, 1, 1, 0,-1,-1,-1 };

/*  */
const short PAT_JEWEL[1+6/*F*/] = {
	-1/**/,
	SPR_JEWEL1,
	SPR_JEWEL2,
	SPR_JEWEL3,
	SPR_JEWEL4,
	SPR_JEWEL5,
	SPR_JEWEL6,
};

/* hN */
const short PAT_SKULL[2/*_*/] = {
	SPR_SKULL0,
	SPR_SKULL1,
};

/*  */
const short PAT_ERASE[7/*Aj[V*/] = {
	SPR_ERASE0,
	SPR_ERASE1,
	SPR_ERASE2,
	SPR_ERASE3,
	SPR_ERASE4,
	SPR_ERASE5,
	SPR_ERASE6,
};

/* Xe[W */
typedef struct _STAGE {
	unsigned char jewel_rows;	/* ΂̍s */
	unsigned char flash_points[9];	/* ΂̊es̃tbV|Cg */
} STAGE;
static const STAGE stage_table[100] = {
	{0,{0}},			/*--*/
	{5,{0,1,0,0,0}},		/* 1*/
	{5,{0,0,1,0,0}},		/* 2*/
	{5,{0,1,1,0,0}},		/* 3*/
	{5,{0,0,0,1,0}},		/* 4*/
	{5,{0,1,0,1,0}},		/* 5*/
	{5,{0,0,1,1,0}},		/* 6*/
	{5,{0,1,1,1,0}},		/* 7*/
	{6,{0,1,0,0,0,0}},		/* 8*/
	{6,{0,0,1,0,0,0}},		/* 9*/
	{6,{0,1,1,0,0,0}},		/*10*/
	{6,{0,0,0,1,0,0}},		/*11*/
	{6,{0,1,0,1,0,0}},		/*12*/
	{6,{0,0,1,1,0,0}},		/*13*/
	{6,{0,1,1,1,0,0}},		/*14*/
	{6,{0,0,0,0,1,0}},		/*15*/
	{6,{0,1,0,0,1,0}},		/*16*/
	{6,{0,0,1,0,1,0}},		/*17*/
	{6,{0,1,1,0,1,0}},		/*18*/
	{6,{0,0,0,1,1,0}},		/*19*/
	{6,{0,1,0,1,1,0}},		/*20*/
	{6,{0,0,1,1,1,0}},		/*21*/
	{6,{0,1,1,1,1,0}},		/*22*/
	{7,{0,1,0,0,0,0,0}},		/*23*/
	{7,{0,0,1,0,0,0,0}},		/*24*/
	{7,{0,1,1,0,0,0,0}},		/*25*/
	{7,{0,0,0,1,0,0,0}},		/*26*/
	{7,{0,1,0,1,0,0,0}},		/*27*/
	{7,{0,0,1,1,0,0,0}},		/*28*/
	{7,{0,1,1,1,0,0,0}},		/*29*/
	{7,{0,0,0,0,1,0,0}},		/*30*/
	{7,{0,1,0,0,1,0,0}},		/*31*/
	{7,{0,0,1,0,1,0,0}},		/*32*/
	{7,{0,1,1,0,1,0,0}},		/*33*/
	{7,{0,0,0,1,1,0,0}},		/*34*/
	{7,{0,1,0,1,1,0,0}},		/*35*/
	{7,{0,0,1,1,1,0,0}},		/*36*/
	{7,{0,1,1,1,1,0,0}},		/*37*/
	{8,{0,1,0,0,0,0,0,0}},		/*38*/
	{8,{0,0,1,0,0,0,0,0}},		/*39*/
	{8,{0,1,1,0,0,0,0,0}},		/*40*/
	{8,{0,0,0,1,0,0,0,0}},		/*41*/
	{8,{0,1,0,1,0,0,0,0}},		/*42*/
	{8,{0,0,1,1,0,0,0,0}},		/*43*/
	{8,{0,1,1,1,0,0,0,0}},		/*44*/
	{8,{0,0,0,0,1,0,0,0}},		/*45*/
	{8,{0,1,0,0,1,0,0,0}},		/*46*/
	{8,{0,0,1,0,1,0,0,0}},		/*47*/
	{8,{0,1,1,0,1,0,0,0}},		/*48*/
	{8,{0,0,0,1,1,0,0,0}},		/*49*/
	{8,{0,1,0,1,1,0,0,0}},		/*50*/
	{8,{0,0,1,1,1,0,0,0}},		/*51*/
	{8,{0,1,1,1,1,0,0,0}},		/*52*/
	{8,{0,0,0,0,0,1,0,0}},		/*53*/
	{8,{0,1,0,0,0,1,0,0}},		/*54*/
	{8,{0,0,1,0,0,1,0,0}},		/*55*/
	{8,{0,1,1,0,0,1,0,0}},		/*56*/
	{8,{0,0,0,1,0,1,0,0}},		/*57*/
	{8,{0,1,0,1,0,1,0,0}},		/*58*/
	{8,{0,0,1,1,0,1,0,0}},		/*59*/
	{8,{0,1,1,1,0,1,0,0}},		/*60*/
	{8,{0,0,0,0,1,1,0,0}},		/*61*/
	{8,{0,1,0,0,1,1,0,0}},		/*62*/
	{8,{0,0,1,0,1,1,0,0}},		/*63*/
	{8,{0,1,1,0,1,1,0,0}},		/*64*/
	{8,{0,0,0,1,1,1,0,0}},		/*65*/
	{8,{0,1,0,1,1,1,0,0}},		/*66*/
	{8,{0,0,1,1,1,1,0,0}},		/*67*/
	{8,{0,1,1,1,1,1,0,0}},		/*68*/
	{9,{0,1,0,0,0,0,0,0,0}},	/*69*/
	{9,{0,0,1,0,0,0,0,0,0}},	/*70*/
	{9,{0,1,1,0,0,0,0,0,0}},	/*71*/
	{9,{0,0,0,1,0,0,0,0,0}},	/*72*/
	{9,{0,1,0,1,0,0,0,0,0}},	/*73*/
	{9,{0,0,1,1,0,0,0,0,0}},	/*74*/
	{9,{0,1,1,1,0,0,0,0,0}},	/*75*/
	{9,{0,0,0,0,1,0,0,0,0}},	/*76*/
	{9,{0,1,0,0,1,0,0,0,0}},	/*77*/
	{9,{0,0,1,0,1,0,0,0,0}},	/*78*/
	{9,{0,1,1,0,1,0,0,0,0}},	/*79*/
	{9,{0,0,0,1,1,0,0,0,0}},	/*80*/
	{9,{0,1,0,1,1,0,0,0,0}},	/*81*/
	{9,{0,0,1,1,1,0,0,0,0}},	/*82*/
	{9,{0,1,1,1,1,0,0,0,0}},	/*83*/
	{9,{0,0,0,0,0,1,0,0,0}},	/*84*/
	{9,{0,1,0,0,0,1,0,0,0}},	/*85*/
	{9,{0,0,1,0,0,1,0,0,0}},	/*86*/
	{9,{0,1,1,0,0,1,0,0,0}},	/*87*/
	{9,{0,0,0,1,0,1,0,0,0}},	/*88*/
	{9,{0,1,0,1,0,1,0,0,0}},	/*89*/
	{9,{0,0,1,1,0,1,0,0,0}},	/*90*/
	{9,{0,1,1,1,0,1,0,0,0}},	/*91*/
	{9,{0,0,0,0,1,1,0,0,0}},	/*92*/
	{9,{0,1,0,0,1,1,0,0,0}},	/*93*/
	{9,{0,0,1,0,1,1,0,0,0}},	/*94*/
	{9,{0,1,1,0,1,1,0,0,0}},	/*95*/
	{9,{0,0,0,1,1,1,0,0,0}},	/*96*/
	{9,{0,1,0,1,1,1,0,0,0}},	/*97*/
	{9,{0,0,1,1,1,1,0,0,0}},	/*98*/
	{9,{0,3,3,3,3,3,3,3,0}},	/*99*/
};

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	/* B */
	app_init();

	/* C[vB */
	for(;;) {
		schedule(); /* gKNÂ */
		if(demo_main() < 0) {
			break;
		}
		schedule(); /* gKNÂ */
		game_main();
	}

	return 0;
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	/* ʓIȏB */
	pceAppSetProcPeriod(1000 / FPS);
#ifdef V_SCREEN
	pceLCDSetBuffer(_def_vbuff);
#else /*V_SCREEN*/
	pceLCDSetBuffer(vbuff);
#endif /*V_SCREEN*/
	pceLCDDispStart();
#ifdef QUICK_REPEAT
	pcePadSetTrigMode(PP_MODE_SINGLE);
#endif /*QUICK_REPEAT*/

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
#ifdef USE_3D
	surface.zbuff = zbuff;
	render_init_3d(&render, &surface, 0, 0, 0, 0, FRONT, BACK, FOVY);
#else /*USE_3D*/
	render_init_2d(&render, &surface, 0, 0, 0, 0);
#endif /*USE_3D*/

#if defined(TRACE_ON) && (TRACE_ON)
	/* WG[o͂J܂B */
	stderr_open(9/*WG[o̓j^ڑ҂()*/);
#endif /*TRACE_ON*/

#ifdef USE_UFE
	/* USBt@CVXeG~[VJn܂B */
	ufe_setup(9/*PCt@CT[oڑ҂()*/);
#endif /*USE_UFE*/

#ifdef TURBO
	/* NbNEEFCgؑւ܂B */
	turbo(TURBO);
#endif /*TURBO*/

#ifdef USE_GC
	/* K[x[WRN^[܂B */
	gc_init();
#endif /*USE_GC*/

#ifdef USE_TCPIP
	/* TCP/IPvgRXC[gJn܂B */
	tcpip_start(0/*EthernethCoMobt@TCY()*/);
#endif /*USE_TCPIP*/

#ifdef LDIRECT_INTERVAL
	/* ؑցE16K\܂B */
	ldirect_init(LDIRECT_INTERVAL);
#endif /*LDIRECT_INTERVAL*/

#ifdef USE_MUSIC
	/* yCu܂B */
	music_loudness(1);
	loadInst(); /* uRandomism Zone(http://www8.plala.or.jp/randomism/)v́whFLbgver.2.10xgp */
	InitMusic();
#endif /*USE_MUSIC*/

	/* N[Abv֐o^B */
	atexit(app_exit);

	/* eNX`܂B */
#ifdef TEXTURE_LIST
	{
		typedef const unsigned char TEXTURE_DATA[];
		extern TEXTURE_DATA TEXTURE_LIST;
		texture_table_init(texture_table, sizeof texture_table / sizeof *texture_table, TEXTURE_LIST);
	}
#endif /*TEXTURE_LIST*/

#ifdef USE_SPRITE
	/* ȈՃXvCghCo܂B */
	sprite_init(&render, sprite_table, SPRITE_COUNT, texture_table, TEXTURE_COUNT);
#endif /*USE_SPRITE*/

/*{{AvP[VL̏*/
	srand(pceTimerGetCount());
	hiscore   = 1000;
	stage_sel = 1;
	color_sel = 6;
/*}}AvP[VL̏*/
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
#ifdef USE_MUSIC
	/* mɉyt~܂B
	 * TEh̒~̓CupceAppExit()ōsĂ̂ŁA
	 * ł͕Kv܂B
	 */
	StopMusic();
	music_loudness(0);
#endif /*USE_MUSIC*/

#ifdef LDIRECT_INTERVAL
	/* ؑցE16K\܂B */
	ldirect_free();
#endif /*LDIRECT_INTERVAL*/

#ifdef USE_TCPIP
	/* TCP/IPvgRXC[gI܂B */
	tcpip_stop();
#endif /*USE_TCPIP*/

#ifdef USE_GC
	/* K[x[WRN^[܂B */
	gc_free();
#endif /*USE_GC*/

#ifdef USE_UFE
	/* USBt@CVXeG~[VI܂B */
	ufe_stop();
#endif /*USE_UFE*/
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
#ifdef QUICK_REPEAT
	static unsigned char rep[8]; /* I[gs[gJE^ */
#endif /*QUICK_REPEAT*/

	int x __attribute__((unused));
	int y __attribute__((unused));

#ifdef USE_PAUSE
	int pause;
	/* PAUSEbZ[Ẅ̃C[Wޔpobt@́A324oCgKvłB
	 * X^bNɎ̂͊댯łAstaticɎ̖̂ʂłB
	 * ŁAPAUSEɂ̂݃q[vmۂ邱Ƃɂ܂B
	 */
	//unsigned char save[PAUSE_H][PAUSE_W];
	unsigned char (*save)[PAUSE_W] = NULL/*x}*/;

	pause = 0;
	for(;;) {
#endif /*USE_PAUSE*/

#ifdef V_SCREEN
		{ /* vbuff(c)_def_vbuff()ϊ */
			unsigned char *dst, *src;
			dst = &_def_vbuff[0];     /* ]̉ʂ͍ォ瑖Jn܂ */
			src = &vbuff[DISP_X - 1]; /* ]̏cʂ͉Eォ瑖Jn܂ */
			for(x = DISP_X - 1; x >= 0; x--) {
				for(y = 0; y < DISP_Y; y++) {
					*dst = *src;
					dst += 1;      /* ʂEɑ܂ */
					src += DISP_X; /* cʂɑ܂ */
				}
				                            /* ʂ͊Ɏ̍sֈړĂ܂ */
				src -= DISP_X * DISP_Y + 1; /* cʂ̗̈ԏֈړ܂ */
			}
		}
#endif /*V_SCREEN*/
		pceLCDTrans();		/* ʍXV */
		yield();		/* VXe */
		joy = pcePadGet();	/* pbhԍXV */
#ifdef V_SCREEN
		joy = (joy & ~(PAD_LF | PAD_RI | PAD_UP | PAD_DN | /* cʗp͕ϊ */
			       TRG_LF | TRG_RI | TRG_UP | TRG_DN))
			| (joy & PAD_LF ? PAD_UP : 0)
			| (joy & PAD_RI ? PAD_DN : 0)
			| (joy & PAD_UP ? PAD_RI : 0)
			| (joy & PAD_DN ? PAD_LF : 0)
			| (joy & TRG_LF ? TRG_UP : 0)
			| (joy & TRG_RI ? TRG_DN : 0)
			| (joy & TRG_UP ? TRG_RI : 0)
			| (joy & TRG_DN ? TRG_LF : 0);
#endif /*V_SCREEN*/

#ifdef USE_PAUSE
		/* PAUSEB */
		if(joy & TRG_START) {
			pause = !pause;	/* PAUSEԐ؂ւ */
			if(pause) {	/* PAUSE IN */
				/* PAUSEbZ[W\̃C[WޔB */
				save = (unsigned char (*)[PAUSE_W])malloc(PAUSE_W * PAUSE_H); /* C[Wޔpobt@m */
				if(save == NULL) DIE();
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						save[y][x] = vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)];
					}
				}
			} else {	/* PAUSE OUT */
				/* PAUSEbZ[W\̃C[W𕜋AB */
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
					}
				}
				free(save); /* C[Wޔpobt@J */
			}
		}
		if(!pause) break;

		/* PAUSEbZ[W_ŕ\B */
		if(pceTimerGetCount() % 1000 < 750) {
			render_string_framed(&render, PAUSE_X, PAUSE_Y, PAUSE_STR, PAUSE_FONT, PAUSE_COLOR);
		} else {
			for(y = 0; y < PAUSE_H; y++) {
				for(x = 0; x < PAUSE_W; x++) {
					vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
				}
			}
		}
	}
#endif /*USE_PAUSE */

#ifdef QUICK_REPEAT
	/* I[gs[gB */
	for(x = 0; x < 8; x++) {
		y = 1 << x; /* PAD_* */
		if(QUICK_REPEAT_PADS & y) {
			if(joy & y) {
				if(rep[x] != 0xff) rep[x]++;
				if(rep[x] >= QUICK_REPEAT_DELAY) joy |= y << 8; /* TRG_* */
			} else {
				rep[x] = 0;
			}
		}
	}
#endif QUICK_REPEAT

	now++;	/* O[o^C}XV */
}

/****************************************************************************
 *	delay
 ****************************************************************************/

void
delay(int frame)
{
	while(frame > 0) {
		schedule();
		frame--;
	}
}

/****************************************************************************
 *	demo_main
 ****************************************************************************/

int
demo_main()
{
	int result;
	int x;
	int y;
	int sel = 0;

	for(;;) {
		schedule();

		/* X^[gHIH */
		if(joy & TRG_A) {
			result = 0;
			break;
		}
		if(joy & TRG_SELECT) {
			result = -1;
			break;
		}

		/* JnXe[WA΂̐FIB */
		if(joy & TRG_UP) {
			sel = 0;
		}
		if(joy & TRG_DN) {
			sel = 1;
		}
		if(!sel) {
			if((joy & TRG_LF) && (stage_sel > 1)) {
				stage_sel--;
			}
			if((joy & TRG_RI) && (stage_sel < 99)) {
				stage_sel++;
			}
		} else {
			if((joy & TRG_LF) && (color_sel > 3)) {
				color_sel--;
			}
			if((joy & TRG_RI) && (color_sel < 6)) {
				color_sel++;
			}
		}

		/* ^Cg\B */
		sprite_draw(0, 0, SPR_TITLE, 0);
		y = 16;
		sprite_draw(0, 16, SPR_LOGO, 0);
		x = 30;
		y += 36;
		render_string_framed(&render, x + 16, y, "", 0x80, 0x130);
		render_string_framed(&render, x +  8, y, "", 0x80, 0x130);
		render_string_framed(&render, x +  0, y, "", 0x80, 0x130);

		/* XRA\B */
		x = 1;
		y = 1;
		render_printf_framed(&render, x, y, 0x82, 1, "1P %05d", game.score);
		render_printf_framed(&render, x, y, 0x82, 3, "1P %5d",  game.score);
		x = DISP_X - 34;
		y = 1;
		render_printf_framed(&render, x, y, 0x82, 1,  "HI %05d", hiscore);
		render_printf_framed(&render, x, y, 0x82, 3,  "HI %5d",  hiscore);

		/* JnXe[WA΂̐F̕\B */
		x = (DISP_X - 4 * 12) / 2 - 1;
		y = 80;
		if(!sel) {
			if(stage_sel == 1) {
				render_printf_framed(&render, x, y, 0x82, 3, "  STAGE %2d >", stage_sel);
			} else if(stage_sel == 99) {
				render_printf_framed(&render, x, y, 0x82, 3, "< STAGE %2d  ", stage_sel);
			} else {
				render_printf_framed(&render, x, y, 0x82, 3, "< STAGE %2d >", stage_sel);
			}
		} else {
				render_printf_framed(&render, x, y, 0x82, 2, "  STAGE %2d  ", stage_sel);
		}
		//
		y += 9;
		if(sel) {
			if(color_sel == 3) {
				render_printf_framed(&render, x, y, 0x82, 3, "  COLORS%2d >", color_sel);
			} else if(color_sel == 6) {
				render_printf_framed(&render, x, y, 0x82, 3, "< COLORS%2d  ", color_sel);
			} else {
				render_printf_framed(&render, x, y, 0x82, 3, "< COLORS%2d >", color_sel);
			}
		} else {
				render_printf_framed(&render, x, y, 0x82, 2, "  COLORS%2d  ", color_sel);
		}

		/* vvg\B */
		if(now % SEC(1) < SEC(0.75)) {
			x = (DISP_X - 4 * 8) / 2 - 1;
			y = DISP_Y - 18;
			render_string_framed(&render, x, y, " A START", 0x82, 3);
			y += 9;
			render_string_framed(&render, x, y, "SEL EXIT", 0x82, 3);
		}
	}

	return result;
}

/****************************************************************************
 *	game_main
 ****************************************************************************/

void
levelup_test()
{
#define LEVEL_SUB_MAX 30 /*  */

	while(game.level_sub >= LEVEL_SUB_MAX) {
		game.level_sub -= LEVEL_SUB_MAX;
		//
		MOVE_SPEED = fmul(MOVE_SPEED, MOVE_SPEED_MULT);
		if(fcom(MOVE_SPEED, <, MOVE_SPEED_MIN)) { /* L蓾ȂƎvAÔ */
			MOVE_SPEED = MOVE_SPEED_MIN;
		}
		if(fcom(MOVE_SPEED, >, MOVE_SPEED_MAX)) {
			MOVE_SPEED = MOVE_SPEED_MAX;
		}
	}

#undef LEVEL_SUB_MAX
}

static void
move_init()
{
	int i;

	/* xAbv()s܂B */
	levelup_test();

	/* ONEXT΂Äړ΂Ƃ܂B */
	memcpy(game.move, game.next, sizeof(CELL) * 3);

	/* VNEXT΂𐶐܂B */
	for(i = 0; i < 3; i++) {
		game.next[i].color = RND16_RANGE(game.seed, 0, COLORS) + 1/*F1x[X*/;
	}

	/* ړ΂̈ʒuAԂȂǂ܂B */
	game.move_col   = FIELD_COLS / 2;
	game.move_row   = 0;
	game.move_ofs   = fild(0);
	game.move_spd   = MOVE_SPEED;
	game.move_stat  = MOVE_STAT_WAIT;
	game.move_delay = MOVE_WAIT_DELAY;
	//
	game.chain       = 0;
	game.skull_erase = 0;
}

static void
move_realize()
{
	int i;
	int col;
	int row;
	CELL* cell;

	for(i = 0; i < 3; i++) {
		col = game.move_col;
		row = game.move_row + i;
		cell = &game.field[row][col];
		memset(cell, 0, sizeof(CELL));
		cell->color = game.move[i].color;
	}
}

static int
field_init_test_sub(int col, int row, int color, int dir)
{
	CELL* cell;

	if((col < 0) || (col > FIELD_COLS - 1) ||
	   (row < 0) || (row > FIELD_ROWS - 1)) {
		return 0;
	}

	cell = &game.field[row][col];
	if(cell->color != color) {
		return 0;
	}

	return field_init_test_sub(
		col + dir_col[dir],
		row + dir_row[dir], color, dir) + 1/*̕*/;
}

static int
field_init_test()
{
	int col;
	int row;
	int dir;
	CELL* cell;

	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &game.field[row][col];
			if(!cell->color) {
				continue;
			}
			for(dir = 0; dir < 4; dir++) {
				if(field_init_test_sub(col, row, cell->color, dir) >= 3) {
					return 0; /* Oȏ̕їL */
				}
			}
		}
	}

	return 1;
}

static void
field_init()
{
	const STAGE* stage = &stage_table[game.stage];
	int jewel_rows = stage->jewel_rows;
	const unsigned char* flash_points = stage->flash_points;
	//
	int i;
	int n;
	int col;
	int row;
	int cnt;
	CELL* cell;
	unsigned char v[FIELD_COLS];

	/* ΂1sȏKvŁAO܂߂3sȏ̋󂫂KvłB */
	if((jewel_rows < 1) || (jewel_rows > FIELD_ROWS - 3)) {
		DIE();
	}

RETRY:
	/* ̉񐔎sA߂čŏ蒼܂B */
	cnt = FIELD_COLS * FIELD_ROWS; /*  */

	/* tB[hNA܂B */
	memset(game.field, 0, sizeof game.field);

	/* ΂𐶐܂B */
	row = FIELD_ROWS - jewel_rows;
	col = 0;
	do {
		if((col < 0) || (col > FIELD_COLS - 1) ||
		   (row < 0) || (row > FIELD_ROWS - 1)) {
			DIE();
		}
		cell = &game.field[row][col];
		if(!cell->work[0]) {
			for(i = 0; i < COLORS; i++) {
				cell->work[i] = i + 1/*F1x[X*/;
			}
			shuffle(cell->work, COLORS, 1, &game.seed);
		}
		for(i = 0; i < COLORS; i++) {
			cell->color = cell->work[0];
			memmove(&cell->work[0], &cell->work[1], COLORS - 1);
			cell->work[COLORS - 1] = cell->color;
			if(field_init_test()) {
				break;
			}
		}
		if(i < COLORS) {
			if(col < FIELD_COLS - 1) {
				col++;
			} else {
				col = 0;
				row++;
			}
		} else {
			if(cnt > 0) {
				--cnt;
			} else {
				goto RETRY;
			}
			cell->color = 0;
			if(col > 0) {
				col--;
			} else {
				col = FIELD_COLS - 1;
				row--;
			}
		}
	} while(row < FIELD_ROWS);

	/* tbV|Cg𐶐܂B */
	row = FIELD_ROWS - jewel_rows;
	do {
		n = *flash_points++;
		if(n > FIELD_COLS) {
			DIE();
		}
		for(i = 0; i < FIELD_COLS; i++) {
			v[i] = i;
		}
		shuffle(v, FIELD_COLS, 1, &game.seed);
		for(i = 0; i < n; i++) {
			col = v[i];
			cell = &game.field[row][col];
			cell->type = CELL_TYPE_FLASH;
		}
		row++;
	} while(row < FIELD_ROWS);
}

static void
stage_init()
{
	/* Xe[W\XN[ʒu܂B */
	game.stage_scroll = 0;

	/* {[hʒuAtB[hŜLƂ܂B */
	FIELD_ROWS = FIELD_ROWS_MAX;

	/* tB[h𐶐܂B */
	field_init();

	/* ŏNEXT΂𐶐Ă܂B */
	move_init();
}

static void
game_init()
{
	/* ܂ANA܂B */
	memset(&game, 0, sizeof game);

	/* V[h܂B */
	game.seed = now;

	/* Xe[Wݒ肵܂B */
	game.stage = stage_sel;

	/* ΂̈ړxݒ肵܂B */
	MOVE_SPEED = MOVE_SPEED_MIN;

	/* hNoݒ肵܂B */
	game.skull_t0 = now;
}

static int
clear_test()
{
	int col;
	int row;
	CELL* cell;

	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &game.field[row][col];
			if(!cell->color) {
				continue;
			}
			if(cell->type == CELL_TYPE_FLASH) {
				return 0; /* _ŕ΂cĂ */
			}
		}
	}

	return 1;
}

static int
gameover_test()
{
	int col;
	int row;
	CELL* cell;

	/* ړ΂ołȂ?
	 * - ړ΂̏oʒuɕ΂ςݏオꍇ
	 * - {[h̃VtgAbvɂALs3sɂȂꍇ (肦ȂƂ͎v...)
	 */
	if(!move_test(FIELD_COLS / 2, 0)) {
		return 1;
	}

	/* O2sɕ΂݂?
	 * ړ΂̏oʒuɏdȂĂȂĂAQ[I[o[łB
	 */
	for(row = 0; row < 2; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &game.field[row][col];
			if(cell->color) {
				return 1;
			}
		}
	}

	return 0;
}

static int
shift_up()
{
	/* {[hʑŜ܂ŏオĂA܂B */
	if(FIELD_ROWS <= 2) {
		return 0;
	}

	/* {[hiグ܂B */
	FIELD_ROWS--;

	/* ΂iグ܂B */
	memmove(&game.field[0                 ][0], &game.field[1][0], sizeof(CELL) * FIELD_COLS_MAX * (FIELD_ROWS_MAX - 1));
	memset (&game.field[FIELD_ROWS_MAX - 1][0],                 0, sizeof(CELL) * FIELD_COLS_MAX                       );

	return 1;
}

static int
shift_down()
{
	int col;
	int row;
	CELL* cell;

	/* {[hiオĂȂ... */
	if(FIELD_ROWS >= FIELD_ROWS_MAX) {

		/* ŉiɕ΂΁A܂B */
		row = FIELD_ROWS_MAX - 1;
		for(col = 0; col < FIELD_COLS_MAX; col++) {
			cell = &game.field[row][col];
			if(cell->color) {
				break;
			}
		}
		if(col == FIELD_COLS_MAX) {
			return 0;
		}

	/* {[hiȏオĂ... */
	} else {

		/* {[hi܂B */
		FIELD_ROWS++;
	}

	/* ΂i܂B */
	memmove(&game.field[1][0], &game.field[0][0], sizeof(CELL) * FIELD_COLS_MAX * (FIELD_ROWS_MAX - 1));
	memset (&game.field[0][0],                 0, sizeof(CELL) * FIELD_COLS_MAX                       );

	return 1;
}

void
game_main()
{
	int i;
	int x;
	int y;
	int col;
	int row;
	int sprno;
	CELL* cell;

	/* Q[܂B */
	game_init();

	for(;;) {
		/* Xe[W܂B */
		stage_init();

		/* Xe[WJnbZ[W\܂B
		 *	"STAGE xx" = ON̂܂
		 *	"  READY " = OFF->ON->OFF->ON->OFF->ON->OFF->ON->OFF
		 * ̊ԁANEXT\łB(dl)
		 */
		for(i = 0; i < SEC(0.5 * 4 + 0.25); i++) {
			if((i >= SEC(0.5)) && (joy & TRG_AB)) {
				break;
			}
			field_disp();
			//
			x = FIELD_X + (CELL_W * 1) - 1;
			y = FIELD_Y + (CELL_H * 7) - 1;
			render_rectangle_fill(&render, x    , y    , CELL_W * 4 + 1, CELL_H * 2 + 1, 1);
			render_rectangle_fill(&render, x + 1, y + 1, CELL_W * 4 - 1, CELL_H * 2 - 1, 3);
			//
			x = FIELD_X + (CELL_W * FIELD_COLS - 4 * 8) / 2;
			y = FIELD_Y + (CELL_H * 7 + 2);
			render_printf(&render, x, y, 0x82, 0, "STAGE %2d", game.stage);
			//
			if(i % SEC(0.5) >= SEC(0.25)) {
				x = FIELD_X + (CELL_W * FIELD_COLS - 4 * 5) / 2;
				y = FIELD_Y + (CELL_H * 8 + 1);
				render_printf(&render, x, y, 0x82, 0, "READY");
			}
			//
			schedule();
		}

		for(;;) {
			/* ړ΂܂B */
			move_init();

			/* ړ΂𗎉܂B */
			for(;;) {
				if(!move_action()) { /* ڒn`ڒ */
					break;
				}
				field_disp();
				move_disp();
				next_disp();
				schedule();
			}

			/* ړ΂̉܂B */
			move_realize();

			for(;;) {
				/* ŃeXgs܂B
				 * łȂ΁A芮łB
				 */
				if(!erase_test()) {
					break;
				}

				/* łAŃANVs܂B */
				for(;;) {
					if(!erase_action()) {
						break;
					}
					field_disp();
					next_disp();
					schedule();
				}

				/* RANVs܂B */
				for(;;) {
					if(!fall_action()) {
						break;
					}
					field_disp();
					next_disp();
					schedule();
				}

				/* Xe[WNAs܂B
				 * Xe[WNAAA𒆒f܂B(dl)
				 */
				if(clear_test()) {
					goto L_CLEAR;
				}

				/* AJE^𑝂₵܂B */
				game.chain++;
			}

			/*{{BR}h*/
			if((joy & PAD_SELECT) && (joy & PAD_DN)) {
				goto L_CLEAR;
			}
			/*}}BR}h*/

			/* 芮AɏEFCgB */
			for(i = 0; i < SEC(0.5)/**/; i++) {
				field_disp();
				next_disp();
				schedule();
			}

			/* - ݂̈ŃhNłA{[hVtgAbv܂B
			 *   œȏ̃hNłĂAVtgAbv͈񂾂łB
			 * - {́ANormalݒœiVtgAbv܂B
			 *   Easyݒł͈iVtgAbv݂łA{vOł͓iŒƂ܂B
			 */
			if(game.skull_erase) {
				for(i = 0; i < 2; i++) {
					if(!shift_up()) {
						break;
					}
					field_disp();
					next_disp();
					schedule();
				}

				/* VtgAbvAEFCgB(Ԃ...) */
				for(i = 0; i < SEC(0.5)/**/; i++) {
					field_disp();
					next_disp();
					schedule();
				}
			}

			/* Q[I[o[s܂B */
			if(gameover_test()) {
				goto L_GAMEOVER;
			}

			/* hNos܂B
			 * {́AQ[I[o[OɏodlłAƒfŃQ[I[o[ɕύX܂B
			 * tB[h܂ɁAhNoāAɃQ[I[o[ɂȂƖӖłB
			 */
			/*{{BR}h*/
			if((joy & PAD_SELECT) && (joy & PAD_UP)) {
				game.skull_t0 = now - SKULL_INTERVAL;
			}
			/*}}BR}h*/
			if((now - game.skull_t0) >= SKULL_INTERVAL) {

				/* hNo\Ȃ... */
				if(skull_gen(&col, &row)) {

					/* hNoOx\܂B */
					for(i = 0; i < 18 * 2 + 9; i++) {
						if((i >= SEC(0.5)) && (joy & TRG_AB)) {
							break;
						}
						field_disp();
						next_disp();
						//
						x = FIELD_X + (CELL_W * 1) - 1;
						y = FIELD_Y + (CELL_H * 5) - 1;
						render_rectangle_fill(&render, x    , y    , CELL_W * 4 + 1, CELL_H * 2 + 1, 1);
						render_rectangle_fill(&render, x + 1, y + 1, CELL_W * 4 - 1, CELL_H * 2 - 1, 3);
						//
						x = FIELD_X + (CELL_W * FIELD_COLS - 4 * 8) / 2;
						y = FIELD_Y + (CELL_H * 5 + 1);
						render_string(&render, x, y, "WARNING!", 0x82, 0);
						//
						x = FIELD_X + (CELL_W * 3 - 4);
						y = FIELD_Y + (CELL_H * 6 - 1);
						if(i % 18 < 9) {
							sprno = PAT_SKULL[0];
						} else {
							cell = &game.field[row][col];
							sprno = PAT_JEWEL[cell->color];
						}
						sprite_draw(x, y, sprno, 0);
						//
						schedule();
					}

					/* ʏ΂ЂƂAhNɕς܂B */
					game.field[row][col].type = CELL_TYPE_SKULL;

					/* hNoɃEFCg͕sv!! Ɏ̈ړ΂o܂B */
				}

				/* hNoĐݒ肵܂B
				 * ۂɃhNoۂɂ炸AZbg܂B(dl)
				 */
				game.skull_t0 = now;
			}
		}

L_CLEAR:

		/* Xe[WNA\܂B
		 * tB[hVtg_EƁA莞"STAGE CLEAR!"\܂B
		 * ̊ԁANEXT\łB(dl)
		 */
		for(;;) {
			if(now & 1) {
				if(!shift_down()) {
					break;
				}
			}
			field_disp();
			schedule();
		}
		//
		for(i = 0; i < SEC(2); i++) {
			if((i >= SEC(0.5)) && (joy & TRG_AB)) {
				break;
			}
			field_disp();
			//
			x = FIELD_X + (CELL_W * 0) - 1;
			y = FIELD_Y + (CELL_H * 8) - 2;
			render_rectangle_fill(&render, x    , y    , CELL_W * 6 + 1, CELL_H * 1 + 2, 1);
			render_rectangle_fill(&render, x + 1, y + 1, CELL_W * 6 - 1, CELL_H * 1    , 3);
			//
			x = FIELD_X + (CELL_W * FIELD_COLS - 4 * 12) / 2;
			y = FIELD_Y + (CELL_H * 8 + 1);
			render_printf(&render, x, y, 0x82, 0, "STAGE CLEAR!", game.stage);
			//
			schedule();
		}

		/* Xe[W߂܂B */
		if(game.stage < 99) {
			game.stage++;
		}
	}

L_GAMEOVER:

	/* Q[I[o[\B */
	for(;;) {
		if(!shift_up()) {
			break;
		}
		field_disp();
		schedule();
	}
	//
	memset(game.field, 0, sizeof game.field); /* ʊO̕΂NA (Kv!!) */
	for(i = 0; i < SEC(0.75); i++) {
		if(joy & TRG_AB) {
			break;
		}
		field_disp();
		schedule();
	}
	//
#define GAMEOVER_Y (FIELD_Y + (CELL_H * 7 - 5))
	x = FIELD_X + (CELL_W * FIELD_COLS - 5 * 9) / 2;
	y = GAMEOVER_Y;
	while(y > -10) {
		y -= 5;
	}
	for(i = 0; i < SEC(10); i++) {
		shift_down();
		field_disp();
		//
		y += 5;
		if(y > GAMEOVER_Y) {
			y = GAMEOVER_Y;
			if(joy & TRG_AB) {
				break;
			}
		}
		if(y < GAMEOVER_Y) {
			render_string(&render, x, y, "GAME OVER", 0x80, 0);
		} else {
			render_rectangle_fill(&render, FIELD_X, FIELD_Y + CELL_H * 6,
				CELL_W * FIELD_COLS_MAX - 1, CELL_H * 2 - 1, 3);
			render_string(&render, x, y, "GAME OVER", 0x80, now & 2);
		}
		//
		schedule();
	}
#undef GAMEOVER_Y

	/* nCXRAXV܂B */
	if(game.score > hiscore) {
		hiscore = game.score;
	}

	/* ReBj[̂߂ɁAXe[WIXV邱Ƃɂ܂B */
	stage_sel = game.stage;
}

/****************************************************************************
 *	score_add
 ****************************************************************************/

void
score_add(int pts)
{
	game.score += pts;
	if(game.score > 99999) {
		game.score = 99999;
	}
}

/****************************************************************************
 *	field_disp
 ****************************************************************************/

static void
field_clip(int on)
{
	if(on) {
		render.left   = FIELD_LEFT;
		render.top    = FIELD_TOP;
		render.right  = FIELD_RIGHT;
		render.bottom = FIELD_BOTTOM;
	} else {
		render.left   = 0;
		render.top    = 0;
		render.right  = DISP_X;
		render.bottom = DISP_Y;
	}
}

void
field_disp()
{
	int i;
	int x;
	int y;
	int col;
	int row;
	int sprno;
	CELL* cell;
	char s1[9];
	char s2[9];

	/* tB[hg`܂B */
	sprite_draw(0, 0, SPR_FIELD, 0);

	/* NbsOݒ肵܂B */
	field_clip(1);

	/* ΂`܂B */
	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &game.field[row][col];
			if(!cell->color) {
				continue;
			}
			x = FIELD_X + col * CELL_W;
			y = FIELD_Y + row * CELL_H;

			sprno = PAT_JEWEL[cell->color];

			switch(cell->stat) {

			case CELL_STAT_NORMAL:
				switch(cell->type) {
				case CELL_TYPE_FLASH:
					if(now % 6 < 3) {
						sprno = -1;
					}
					break;
				case CELL_TYPE_SKULL:
					if(now % 18 < 9) {
						sprno = PAT_SKULL[0];
					}
					break;
				}
				break;

			case CELL_STAT_ERASE:
				if(cell->count < 0) {
					switch(cell->type) {
					case CELL_TYPE_NORMAL:
					case CELL_TYPE_FLASH:
						if(now % 3 < 1) {
							sprno = -1;
						}
						break;
					case CELL_TYPE_SKULL:
						if(now % 3 < 1) {
							sprno = PAT_SKULL[0];
						} else {
							sprno = PAT_SKULL[1];
						}
						break;
					}
				} else if(cell->count < 7) {
					sprno = PAT_ERASE[cell->count];
				} else {
					sprno = -1;
				}
				break;

			default:
				DIE();
			}

			if(sprno >= 0) {
				/*{{΂ƃObhאڂƌÂ炢̂ŏ܂B*/
				render_rectangle(&render, x - 1, y - 1, CELL_W + 1, CELL_H + 1, 3);
				/*}}΂ƃObhאڂƌÂ炢̂ŏ܂B*/
				sprite_draw(x, y, sprno, 0);
			}
		}
	}

	/* {[h`܂B */
	x = FIELD_X;
	y = FIELD_Y + FIELD_ROWS * CELL_H;
	sprite_draw(x, y, SPR_BOARD, 0);

	/*------------------------------------------------------------------*/

	/* NbsOݒ肵܂B */
	render.left   = STAGE_LEFT;
	render.top    = STAGE_TOP;
	render.right  = STAGE_RIGHT;
	render.bottom = STAGE_BOTTOM;

	/* Xe[W`܂B */
	sprintf(s1, "%2d", game.stage - 1);
	sprintf(s2, "%2d", game.stage);
	for(i = 0; i < 2; i++) {
		x = STAGE_X + 8 * i;
		y = STAGE_Y;
		if((s1[i] != s2[i]) && (game.stage_scroll < 16)) {
			render_font(&render, x, y - game.stage_scroll,      s1[i], 0x81, 0);
			render_font(&render, x, y - game.stage_scroll + 16, s2[i], 0x81, 0);
		} else {
			render_font(&render, x, y,                          s2[i], 0x81, 0);
		}
	}
	if(game.stage_scroll < 16) {
		game.stage_scroll += 2;
	}

	/*------------------------------------------------------------------*/

	/* NbsO܂B */
	field_clip(0);

	/* XRA`܂B */
	render_printf(&render, SCORE_X, SCORE_Y, 0x82, 1, "%5d", game.score);

	/* ΐ`܂B */
	render_printf(&render, JEWELS_X, JEWELS_Y, 0x82, 1, "%5d", game.jewels);
}

/****************************************************************************
 *	move_disp, next_disp
 ****************************************************************************/

void
move_disp_sub(const CELL cell[/*3*/], int x, int y)
{
	int i;
	int sprno;

	for(i = 0; i < 3; i++) {
		sprno = PAT_JEWEL[cell[i].color];
		sprite_draw(x, y, sprno, 0);
		y += CELL_H;
	}
}

void
move_disp()
{
	int x;
	int y;
	fixed ofs;

	field_clip(1);

	x = FIELD_X + game.move_col * CELL_W;
	y = FIELD_Y + game.move_row * CELL_H;
	ofs = game.move_ofs;
	while(fcom(ofs, >, fld(0.5))) {	/* 1.0ofs0.5 ...  1Z */
		y -= CELL_H;
		ofs = fsub(ofs, fld(1.0));
	}
	if(fcom(ofs, >, fld(0.0))) {	/* 0.5ofs0.0 ... Z */
		y -= CELL_H / 2;
	}

	sprite_draw(x, y, SPR_CURSOR, 0);
	move_disp_sub(game.move, x, y);

	field_clip(0);
}

void
next_disp()
{
	/* ړ΂Sɉʓɕ\܂ł́Aړ΂̕\ێ܂B */
	move_disp_sub(game.move_row < 3 ? game.move : game.next, NEXT_X, NEXT_Y);
}

/****************************************************************************
 *	move_action
 ****************************************************************************/

int
move_action()
{
	int tmp;

	switch(game.move_stat) {

	case MOVE_STAT_WAIT:

		game.move_delay--;
		if((game.move_delay <= 0) || (joy & TRG_DN)/*Jn*/) {
			game.move_stat = MOVE_STAT_FALL;
		}

		break;

	case MOVE_STAT_FALL:

		/* d͉܂B߂炵dlłBقƂǈӖ... */
		if(!(now % 3/**/)) {
			game.move_spd = fadd(game.move_spd, MOVE_ACCEL);
			if(fcom(game.move_spd, >, MOVE_SPEED_MAX)) {
				game.move_spd = MOVE_SPEED_MAX;
			}
		}

		if((joy & PAD_DN) && ficom(game.move_spd, <, 1)) {
			game.move_ofs = fild(0); /*  */
		} else {
			game.move_ofs = fsub(game.move_ofs, game.move_spd);
		}

		while(ficom(game.move_ofs, <=, 0)) {
			if(!move_test(game.move_col, game.move_row + 1)) { /* ڒn? */
				game.move_ofs   = fild(0);
				game.move_spd   = MOVE_SPEED; /* d͉߂ */
				game.move_stat  = MOVE_STAT_LAND;
				game.move_delay = MOVE_LAND_DELAY;
				break;
			}
			game.move_row++; /* ̃Z */
			game.move_ofs = fiadd(game.move_ofs, 1);
			if(joy & PAD_DN) {
				score_add(1);
			}
		}

		break;

	case MOVE_STAT_LAND:

		if(move_test(game.move_col, game.move_row + 1)) {
			game.move_stat = MOVE_STAT_FALL; /* ĊJ */
		} else {
			game.move_delay--;
			if((game.move_delay <= 0) || (joy & TRG_DN)/*ڒ*/) {
				return 0; /* ڒn`ڒ */
			}
		}

		break;

	default:
		DIE();
	}

	/* Eړ󂯕t܂B */
	if(joy & TRG_LF) {
		if(move_test(game.move_col - 1, game.move_row)) {
			game.move_col--;
		}
	}
	if(joy & TRG_RI) {
		if(move_test(game.move_col + 1, game.move_row)) {
			game.move_col++;
		}
	}

	/* ]󂯕t܂B */
	if(joy & TRG_A) {
		tmp = game.move[2].color;
		      game.move[2].color = game.move[1].color;
		                           game.move[1].color = game.move[0].color;
		                                                game.move[0].color = tmp;
	}
	if(joy & TRG_B) {
		tmp = game.move[0].color;
		      game.move[0].color = game.move[1].color;
		                           game.move[1].color = game.move[2].color;
		                                                game.move[2].color = tmp;
	}

	return 1; /* ANVp */
}

/****************************************************************************
 *	move_test
 ****************************************************************************/

int
move_test(int col, int row)
{
	CELL* cell;

	row += 2; /* ΂񉺂̃ZׂΏ[ */

	if((col < 0) || (col > FIELD_COLS - 1)) {
		return 0; /* ړs */
	}

	if((row < 0) || (row > FIELD_ROWS - 1)) {
		return 0; /* ړs */
	}

	cell = &game.field[row][col];
	if(cell->color) {
		return 0; /* ړs */
	}

	return 1; /* ړ\ */
}

/****************************************************************************
 *	erase_test
 ****************************************************************************/

static int
erase_test_sub(int col, int row, int color, int dir, int len)
{
	CELL* cell;

	if((col < 0) || (col > FIELD_COLS - 1) ||
	   (row < 0) || (row > FIELD_ROWS - 1)) {
		return len;
	}

	cell = &game.field[row][col];
	if(cell->color != color) {
		return len;
	}

	len = erase_test_sub(
		col + dir_col[dir],
		row + dir_row[dir], color, dir, len + 1/*̕*/);
	if(len >= 3) {
		cell->stat = CELL_STAT_ERASE;
		cell->count = -ERASE_TIME_BEFORE;
		cell->erase |= (1<<dir);
		if(cell->type == CELL_TYPE_SKULL) {
			game.skull_erase++;
		}
	}

	return len;
}

int
erase_test()
{
	int result = 0;
	int skull_erase_old = game.skull_erase;
	//
	int col;
	int row;
	int dir;
	int len;
	CELL* cell;
	
	/* ΂̕тoAłZbgAbv܂B */
	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &game.field[row][col];
			if(!cell->color) {
				continue;
			}
			for(dir = 0; dir < 4; dir++) {
				if(cell->erase & (1<<dir)) {
					continue;
				}
				len = erase_test_sub(col, row, cell->color, dir, 0);
				if(len >= 3) {
					score_add(30 * (game.chain + 1) * (len - 2)); /* XRAAbv */
					result++;
				}
			}
		}
	}

	/* hNłAׂĂ̏ŕ΂̓_ŎԂǉ܂B */
	if(game.skull_erase != skull_erase_old) {
		for(row = 0; row < FIELD_ROWS; row++) {
			for(col = 0; col < FIELD_COLS; col++) {
				cell = &game.field[row][col];
				if(!cell->color) {
					continue;
				}
				if(cell->stat == CELL_STAT_ERASE) {
					cell->count -= ERASE_TIME_EXTRA;
				}
			}
		}
	}

	return result;
}

/****************************************************************************
 *	erase_action
 ****************************************************************************/

int
erase_action()
{
	int result = 0;
	//
	int col;
	int row;
	CELL* cell;

	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &game.field[row][col];
			if(!cell->color) {
				continue;
			}
			if(cell->stat == CELL_STAT_ERASE) {
				cell->count++;
				if(!cell->count) {
					if(game.jewels < 99999) {
						game.jewels++; /* ΐJEgAbv */
					}
					game.level_sub++; /* xAbvJE^₵܂ */
				}
				if(cell->count >= ERASE_TIME_AFTER) {
					memset(cell, 0, sizeof(CELL));
					continue;
				}
				result++; /* ANVp */
			}
		}
	}

	return result;
}

/****************************************************************************
 *	fall_action
 ****************************************************************************/

int
fall_action()
{
	int result = 0;
	//
	int col;
	int row;
	CELL* cell;

	for(row = FIELD_ROWS - 1; row >= 0; row--) {
		for(col = FIELD_COLS - 1; col >= 0; col--) {
			cell = &game.field[row][col];
			if(!cell->color) {
				continue;
			}
			if((row < FIELD_ROWS - 1) && !(cell + FIELD_COLS)->color) {
				memcpy(cell + FIELD_COLS, cell,    sizeof(CELL));
				memset(                   cell, 0, sizeof(CELL));
				result++; /* ANVp */
			}
		}
	}

	return result;
}

/****************************************************************************
 *	skull_gen
 ****************************************************************************/

static void
skull_gen_sub(int col, int row, int dir, int dist)
{
	CELL* cell;

	col += dir_col[dir];
	row += dir_row[dir];
	if((col < 0) || (col > FIELD_COLS - 1) ||
	   (row < 0) || (row > FIELD_ROWS - 1)) {
		return;
	}
	cell = &game.field[row][col];
	if(!cell->color) {
		return;
	}

	dist++;
	if((cell->type == CELL_TYPE_NORMAL) && (dist < cell->work[0])) {
		cell->work[0] = dist;
	}

	skull_gen_sub(col, row, dir, dist);
}

int
skull_gen(int* skull_col, int* skull_row)
{
	static unsigned short pos[FIELD_COLS_MAX * FIELD_ROWS_MAX];
	//
	int col;
	int row;
	int cnt;
	int dir;
	int dist;
	int dist_max;
	CELL* cell;

	/* - CELL.work[0]A󔒃Z̋Ƃėp܂B
	 *   ʏZCELL.work[0]AőlɂăNAĂ܂B
	 * - ɁÃhN𐔂܂B
	 *   4̃hNoĂAVhN͏o܂B
	 */
	cnt = 0;
	for(row = FIELD_ROWS - 1; row >= 0; row--) {
		for(col = FIELD_COLS - 1; col >= 0; col--) {
			cell = &game.field[row][col];
			if(!cell->color) {
				continue;
			}
			switch(cell->type) {
			case CELL_TYPE_NORMAL:
				cell->work[0] = UCHAR_MAX;
				break;
			case CELL_TYPE_SKULL:
				if(++cnt == 4) {
					return 0;
				}
				break;
			}
		}
	}

	/* ʏZCELL.work[0]ɁA󔒃Z̋i[܂B */
	for(row = FIELD_ROWS - 1; row >= 0; row--) {
		for(col = FIELD_COLS - 1; col >= 0; col--) {
			cell = &game.field[row][col];
			if(!cell->color) {
				for(dir = 0; dir < 8/*4Ȃ!!*/; dir++) {
					skull_gen_sub(col, row, dir, 0);
				}
			}
		}
	}

	/* 󔒃Z̋߂ʒuD悵āAhN𐶐܂B */
	dist_max = FIELD_COLS > FIELD_ROWS ? FIELD_COLS : FIELD_ROWS;
	for(dist = 0; dist < dist_max; dist++) {
		cnt = 0;
		for(row = FIELD_ROWS - 1; row >= 0; row--) {
			for(col = FIELD_COLS - 1; col >= 0; col--) {
				cell = &game.field[row][col];
				if(!cell->color) {
					continue;
				}
				if((cell->type == CELL_TYPE_NORMAL) && (cell->work[0] == dist)) {
					if(cnt < ARRAY_SIZE(pos)) {
						pos[cnt++] = col | row << 8;
					}
				}
			}
		}
		if(cnt) {
			cnt = RND16_RANGE(game.seed, 0, cnt);
			*skull_col = LOBYTE(pos[cnt]);
			*skull_row = HIBYTE(pos[cnt]);
			return 1; /* hN\ */
		}
	}

	return 0; /* hNs */
}
