/*	
 *	framfont.c
 *
 *	RAMɓ]郂W[
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2002 Naoyuki Sawa
 *
 *	* Tue Nov 19 12:30:00 JST 2002 Naoyuki Sawa
 *	- clipdobj.cclipmod.cARs[ECĐVK쐬܂B
 *	* Sun Dec 8 05:43:00 JST 2002 Naoyuki Sawa
 *	- mod_mix()̃[voOCB
 *	- e|GtFNgΉB
 *	* Fri Jan 31 21:57:00 JST 2003 Naoyuki Sawa
 *	- new_LCDDrawObject()PIXEL(p,m)}Nmask蕔ǁB
 *	 u(mask >> (m) & 1)vu(mask & (1 << (m)))vɕύX܂B
 *	  3%(Sʓ])AR[hTCY20oCgȂȂ܂B
 *	  ̉ǂ́uryuǩOH[v(http://www.interq.or.jp/earth/ryuk/)ɂ̂łB
 *	- new_LCDDrawObject()̃NbsOʊO菈ǁB
 *	  ܂ŁA]Ȃ/肻ꂼ̏̒ōsĂ̂AʉĂ܂Ƃ߂܂B
 *	  R[hTCY4oCgȂȂ܂B
 *	- ȏ̕ύXsʁA_̃R[hTCY0xfe0(4064)oCgłB
 *	* Sat Feb 1 14:08:00 JST 2003 Naoyuki Sawa
 *	- new_LCDDrawObject()ɂāAc胉C̎擾uy = obj.dhvʉAeʐߖ񂵂܂B
 *	- MODhCoσ`lɑΉ܂B
 *	* Tue Apr 1 19:00:00 JST 2003 Naoyuki Sawa
 *	- clipfram.c𕪊Ãt@CV݂܂B
 */
#include "clip.h"

/****************************************************************************
 *	[eBeBFtHg
 ****************************************************************************/

/* VvCuput_1char()֐(\usr\PIECE\lib\src\simple\symbol.c)Qlɂ܂B
 * ܂ApceFontPut()֐(\usr\PIECE\sysdev\pcekn\font.c)ɕāAr[|[g/Oɂꍇs܂B
 * tHg`̈悪SɃr[|[gȂANbsOȗA{xɕ`ł܂B
 */
unsigned short
render_font(RENDER* render, int x, int y, unsigned short code, int type, int color)
{
	SURFACE* surface;
	unsigned char* vptr;
	const unsigned char* p;
	int ofs, w, h, x_min, y_min, x_max, y_max, c;

	/* tHgTCY߂܂B */
	type &= 0x7f; /* bit7(sw)͖ */
	if(type < 0 || 2 < type) /*DIE()*/return 0; /* ȃtHg^CvAeʍ팸̂DIE()܂ */
	w = render_font_size[type][0];
	h = render_font_size[type][1];

	 /* p󔒂͕pɂɎw肳Ǝv̂ŁA`ȗč܂B
	  * w,h͖߂lɎĝŁAw,h擾OɃXLbvȂ悤ӁI
	  */
	if(code == ' ') goto SKIP;

	/* tHgAhX߂܂B */
	pceFontSetType(type);
	p = pceFontGetAdrs(code);

	/* ptHg`c */
	if((int)p & (1 << 31)) {
		p = (unsigned char*)((int)p & ~(1 << 31)); /* prbg낷 */
		/* `͈͂߂܂B */
		x_min = x;
		y_min = y;
		x_max = x + w;
		y_max = y + h;
		/* SɃr[|[gȂANbsOsvłB */
		if(render->left <= x_min && x_max <= render->right &&
		   render->top  <= y_min && y_max <= render->bottom) {
			surface = render->surface;
			ofs = surface->w * y + x;
			vptr = surface->vbuff + ofs;
			for(y = y_min; y < y_max; y++) {
				c = *p++;
				for(x = x_min; x < x_max; x++) {
					if(c & 0x80) *vptr = color;
					vptr++;
					c <<= 1;
				}
				vptr += surface->w - w; /* ̍s */
			}
		/* r[|[g͂ݏoĂAvNbsOB */
		} else {
			for(y = y_min; y < y_max; y++) {
				c = *p++;
				for(x = x_min; x < x_max; x++) {
					if(c & 0x80) render_point(render, x, y, color);
					c <<= 1;
				}
			}
		}
	/* SptHg`c */
	} else {
		w *= 2; /* SpȂ̂œ񕶎̕B߂lɎĝwύXKv */
		/* `͈͂߂܂B */
		x_min = x;
		y_min = y;
		x_max = x + w;
		y_max = y + h;
		/* SɃr[|[gȂANbsOsvłB */
		if(render->left <= x_min && x_max <= render->right &&
		   render->top  <= y_min && y_max <= render->bottom) {
			surface = render->surface;
			ofs = surface->w * y + x;
			vptr = surface->vbuff + ofs;
			for(y = y_min; y < y_max; y += 2) { /* 2CÂ` */
				c = p[0] << 16 | p[1] << 8 | p[2]; /* 3oCg2C */
				p += 3;
				for(x = x_min; x < x_max; x++) {
					if(c & 0x800000) *(vptr + 0         ) = color;
					if(c &    0x800) *(vptr + surface->w) = color;
					vptr++;
					c <<= 1;
				}
				vptr += surface->w * 2 - w; /* s */
			}
		/* r[|[g͂ݏoĂAvNbsOB */
		} else {
			for(y = y_min; y < y_max; y += 2) { /* 2CÂ` */
				c = p[0] << 16 | p[1] << 8 | p[2]; /* 3oCg2C */
				p += 3;
				for(x = x_min; x < x_max; x++) {
					if(c & 0x800000) render_point(render, x, y + 0, color);
					if(c &    0x800) render_point(render, x, y + 1, color);
					c <<= 1;
				}
			}
		}
	}
SKIP:
	return h << 8 | w;
}

